#ifndef _UTIL_H
#define _UTIL_H

static inline unsigned int string_hash(const char *str)
{
    register unsigned int h = 2166136261u;
    register const char *s = str;
    while(*s) h = (h * 16777619) ^ *s++;
    return h;
}

#define KEY_T void *
#define VALUE_T void *
#define PREFIX(X) ptrhash ## X
#include "util_hash_h.h"
#undef PREFIX
#undef KEY_T
#undef VALUE_T

ptrhash_t * strhash_new();

unsigned int MurmurHash2(const void * key, int len, unsigned int seed);

#endif
