#ifndef _POLY_H
#define _POLY_H

#define POLY_A_XSHIFT 3
#define POLY_A_YSHIFT 2

#define POLY_A_XMULT (1 << POLY_A_XSHIFT)
#define POLY_A_YMULT (1 << POLY_A_YSHIFT)

typedef void (* poly_hline_t) (int x1, int x2, int y);
void scanpoly(int lowx, int highx, int lowy, int highy, int n, int pt[][2], poly_hline_t hline);

/* usage:
 * premultiply all pt[] with POLY_A_XMULT and POLY_A_YMULT.
 * (don't premultiply low/high x/y).
 *
 * callback will be called with a buffer of segments (sorted)
 * for each scanline. coordinates are in pixels */

typedef struct {
	int x1, x2;
	uint8_t alpha;
} poly_hline_segment_t;

typedef void (* poly_hline_a_t) (int y, poly_hline_segment_t *i, poly_hline_segment_t *end, void *data);
void scanpoly_a(int lowx, int highx, int lowy, int highy, int n, int pt[][2], poly_hline_a_t cb, void *data);

#endif
