function redraw()
{
	close_macro()

	print "frame"
	print "ident"
	print "events on"

	print "shift " (-shiftx) " " (-shifty)
	print "scale " zoom
	print "invoke __zoompan__"
	print "flush"
	fflush()
}

function chk_empty_macro()
{
	if (!have_macro) {
		print "macro __zoompan__"
		print "push"
		print "pop"
		print "endmacro"
		have_macro = 1
	}
}

function close_macro()
{
	if (pushing) {
		print "endmacro"
		pushing = 0
	}
}

BEGIN {
	drag=0
	origx=0
	origy=0
	oshiftx=0
	oshifty=0
	shiftx=0
	shifty=0
	zoom=1
	macro=0
	pushing=0
	have_macro=0
}

/^stdin macro/ {
	line=$0
	sub("^stdin ", "", line)
	macro = 1
	close_macro()
	print line
	next
}

/^stdin endmacro/ {
	macro = 0
	line=$0
	sub("^stdin ", "", line)
	print line
	next
}


/^stdin frame/ {
	chk_empty_macro()
	next
}


/^stdin flush/ {
	if (pushing) {
		print "endmacro"
		pushing = 0
	}
	if (!macro)
		redraw()
	next
}

/^stdin bg / {
	line=$0
	sub("^stdin ", "", line)
	print line
	next
}

/^stdin / {
	line=$0
	sub("^stdin ", "", line)
	if (line == "")
		next
	if ((!pushing) && (!macro)) {
		chk_empty_macro()
		print "macro push __zoompan__"
		pushing = 1
	}
	print line
}

function do_zoom(zin)
{
	if (zin) {
		zoom=zoom*1.1
		shiftx=shiftx*1.1
		shifty=shifty*1.1
	}
	else {
		zoom=zoom/1.1
		shiftx=shiftx/1.1
		shifty=shifty/1.1
	}
}


/^anim PRESS/ {
	if($3 == 2) {
		drag=1;
		origx=$4;
		origy=$5;
		oshiftx=shiftx;
		oshifty=shifty;
	} else if($3 == 4) {
		do_zoom(1)
	} else if($3 == 5) {
		do_zoom(0)
	} else if($3 == 1) {
		shiftx=0; shifty=0; zoom=1;
	}
	redraw()
}

/^anim RELEASE/ {
	if($3 == 2) {
		drag=0;
	}
}

/^anim KEYUP 0 z/ {
	do_zoom(1)
	redraw()
}

/^anim KEYUP 1 z/ {
	do_zoom(0)
	redraw()
}

/^anim MOTION/ {
	if(drag) {
		shiftx = oshiftx - ($4 - origx);
		shifty = oshifty - ($5 - origy);
		redraw();
	}
}

