# normal     hot
# <space>    _       Empty
# .          #       White
# X          *       Black
# i          I       Invert

BEGIN {
	hot_x = 0
	hot_y = 0
}

{
	if(NR > 32) {
		print "too many rows" > "/dev/stderr"
		exit 1
	} else if(length($0) > 32) {
		print "row", NR, "too long:", length($0) > "/dev/stderr"
		exit 1
	} else {
		for(i=1; i<=length($0); i++) {
			c = substr($0, i, 1)
			if(c == "_" || c == "#" || c == "*" || c == "I") {
				hot_x = i - 1
				hot_y = NR - 1
			}

			if(c == " " || c == "_") {
				data[NR, i] = 0
				mask[NR, i] = 0
			} else if(c == "." || c == "#") {
				data[NR, i] = 0
				mask[NR, i] = 1
			} else if(c == "X" || c == "*") {
				data[NR, i] = 1
				mask[NR, i] = 1
			} else if(c == "i" || c == "I") {
				data[NR, i] = 1
				mask[NR, i] = 0
			} else {
				print "invalid character", c, "in row", NR > "/dev/stderr"
				exit 1
			}
		}
	}
}

END {
	bitv[0] = 8
	bitv[1] = 4
	bitv[2] = 2
	bitv[3] = 1
	vd = 0
	vm = 0
	outd = ""
	outm = ""
	for(y=1; y<=32; y++) {
		for(x=1; x<=32; x++) {
			d = data[y, x]
			m = mask[y, x]
			bit = (x - 1) % 4
			bv = bitv[bit]
			if(d) vd += bv;
			if(m) vm += bv;
			if(bit == 3) {
				outd = outd sprintf("%x", vd)
				vd = 0
				outm = outm sprintf("%x", vm)
				vm = 0
			}
		}
	}

	print "\"" outd "\" \"" outm "\"", hot_x, hot_y
}
