#!/bin/bash

# this script demonstrates how to avoid redrawing the entire scene for each
# frame
#
# rather, frames are drawn cumulatively; a redraw is only necessary when
# the window is resized
#
# this utilizes the animator -R mode, and plumb (repo.hu/projects/plumb)
# for connecting animator with the awk script

plumb -v prog '
function sq(x,y) {
print "color", t[x,y]
print "fillrect", x, y, "-", x+1, y+1
}

function ssq(x,y,c) {
	t[x,y]=c
	sq(x,y)
}

BEGIN {
	print "shift -1 -1 scale", 2/20, 2/20
	for(x=0; x<20; x++)
		for(y=0; y<20; y++)
			ssq(x, y, sprintf("0 %.2f %.2f", x/20, y/20));
	print "flushdelay 0.1"
	fflush()
}

$1=="FLUSHDELAY" {
	print "frame"

	x=int(rand()*20)
	y=int(rand()*20)
	ssq(x, y, sprintf("%.2f %.2f %.2f", rand(), x/20, y/20))

	print "flushdelay 0.1"
	fflush()
	next
}

$1=="RESIZE" {
	print "frame"
	for(x=0; x<20; x++)
		for(y=0; y<20; y++)
			sq(x, y)
	print "flush"
	fflush()
}

' '
proc a = animator -a -R -e -q
proc p = awk $prog
pipe a p
pipe p a
'
