#!/bin/bash

awk '
function init(n, color) {
	x[n] = rand()*2-1
	y[n] = rand()*2-1
	vx[n] = rand()-0.5
	vy[n] = rand()-0.5
	print "macro push \"" n "\" color " color " endmacro"
}

function step(n, dt, gx, gy,          px, py, dx, dy) {
	px = x[n]
	py = y[n]

	dx = x[n] - gx
	dy = y[n] - dy
	vx[n] = vx[n] - dx * dt
	vy[n] = vy[n] - dy * dt

	x[n] = x[n] + vx[n] * dt
	y[n] = y[n] + vy[n] * dt

	print "macro push \"" n "\" line ", px, py, x[n], y[n], " endmacro"
}

BEGIN {
	init("red", "red")
	init("green", "green")
	init("blue", "blue")

	for(;;) {
		dt = 0.1
		t += dt
		gx = cos(t * 0.1) * 0.1
		gy = sin(t * 0.3) * 0.1
		step("red", dt, gx, gy)
		step("green", dt, gx, gy)
		step("blue", dt, gx, gy)

		rot = t

		print "frame ident rotate", rot, " invoke \"red\" invoke \"green\" invoke \"blue\" flush"
	}
}
'
