function process(num, data)
{
	left=ord(substr(data, 1, 1))-orig
	right=ord(substr(data, 2, 1))-orig
	width = (right - left) * scalex

	if (num in glyphmap)
		printf "! %d %.3f\n", num, width;
	else
		printf "! %d %.3f UNUSED\n", num, width;

	printf "macro hf%d ", num

	bgn=1
	for(i=3; i<length(data); i+=2) {
		p1 = substr(data,i,1)
		p2 = substr(data,i+1,1)
		if(p1 == " " && p2 == "R") {
			bgn=1
		} else {
			if(bgn) {
				bgn=0
				printf "lines "
			}

			x = ord(p1)-orig
			y = ord(p2)-orig

			printf "%f %f ", (x-left)*scalex, (y-scalebottom)*scaley

			if(x < minx) minx = x
			if(x > maxx) maxx = x
			if(y < miny) miny = y
			if(y > maxy) maxy = y
		}
	}
	if(i != length(data)+1) {
		print "data has invalid length " length(data) "," i
		quit
	}

	printf "shift %.3f %.3f endmacro\n", width, 0
}

function ord(c)
{
	if (!(c in ascii)) {
		print "ascii for" c "not found"
		quit
	}
	return ascii[c]
}

BEGIN {
	num=0
	data=""
	for(i=32;i<128;i++)
		ascii[sprintf("%c",i)] = i;
	orig=ord("R")
	minx=0
	maxx=0
	miny=0
	maxy=0

	scaletop=-16
	scalebottom=16
	scaleleft=-14
	scaleright=14

	scalex = 1.0 / (scaleright - scaleleft)
	scaley = 1.0 / (scaletop - scalebottom)

	while((getline < "map") == 1) {
		if($1 == "MAP") {
			map=$2
			fontname[map]=$3
			ascode=32
		} else {
			for(i=1;i<=NF;i++) {
				if(split($i,rg,/-/) > 1) {
					for(j=rg[1]; j<=rg[2]; j++) {
						fontmap[map ascode] = (0+j)
						glyphmap[j] = glyphmap[j] "," map ascode
						ascode ++
					}
				} else {
					fontmap[map ascode] = (0+$i)
					glyphmap[$i] = glyphmap[$i] "," map ascode
					ascode ++
				}
			}
		}
	}

	for(font in fontname) {
		printf "!font " fontname[font]
		for(i=32; i<=127; i++) {
			printf " %d", fontmap[font i]
		}
		printf "\n"
	}
}

/^ *[0-9]+/ {
	if(num != 0) {
		process(num, data)
	}

	num=substr($0, 2, 4)+0
	data=substr($0, 9)
	next
}

{
	data = data $0
}

END {
	if(num != 0) {
		process(num, data)
	}

	#print "minx" minx
	#print "maxx" maxx
	#print "miny" miny
	#print "maxy" maxy
}
